#include <stdio.h>
#include "anadisk.h"

#define DEBUG

FILE	*InFile;	// Anadisk dump file, including sector headers.
FILE	*OutFile;	// OS9 file.

void usage()
{
	printf("Error, usage is :\n\n");
	printf("ana2os9 <anadisk_image> <os9_iamge>\n");
}

void TransferImage()
{
	ANADISK_SECTOR	SecHead;
	char		*Buffer;
	
	while (fread(&SecHead,sizeof(SecHead),1,InFile)!=0)
	{
#ifdef DEBUG
		printf("Actual Cyl=%d, ",SecHead.ActualCyl);
		printf("Actual Head=%d, ",SecHead.ActualHead);
		printf("Log Cyl=%d, ",SecHead.LogicalCyl);
		printf("Log Head=%d, ",SecHead.LogicalHead);
		printf("Log Sector=%d, ",SecHead.LogicalSector);
		printf("Length=%d, ",SecHead.Length);
		printf("DataCount=%d\n",SecHead.DataCount);
#endif
		Buffer=(char *)malloc(SecHead.DataCount);	// Get a buffer for sector data
		fread(Buffer,SecHead.DataCount,1,InFile);	// Read from in, write to out
		fwrite(Buffer,SecHead.DataCount,1,OutFile);
		free(Buffer);					// Free buffer
	}
}

int main(int argc, char *argv[])
{
	if(argc<3)
		usage();
	else
	{
		if((InFile=fopen(argv[1],"rb"))!=NULL)
		{
			if((OutFile=fopen(argv[2],"wb"))!=NULL)
			{
				TransferImage();
				fclose(OutFile);
			}
			else
				printf("Error opening output file %s\n",argv[2]);
			
			fclose(InFile);
		}
		else
			printf("Error opening input file %s\n",argv[1]);
	}

	return 0;
}
